Set Warnings "-notation-overridden,-parsing".
Require Import Typechecking.
Parameter MISSING: Type.   

Module Check.  

Ltac check_type A B :=  
match type of A with  
| context[MISSING] => idtac "Missing:" A  
| ?T => first [unify T B; idtac "Type: ok" | idtac "Type: wrong - should be (" B ")"]  
end.  

Ltac print_manual_grade A :=  
first [  
match eval compute in A with  
| ?T => idtac "Score:" T  
end  
| idtac "Score: Ungraded"].  

End Check.

Require Import Typechecking.
Import Check.

Goal True.

idtac "-------------------  typechecker_extensions  --------------------".
idtac " ".

idtac "#> TypecheckerExtensions.type_checking_sound".
idtac "Possible points: 2".
check_type @TypecheckerExtensions.type_checking_sound (
(forall (Gamma : MoreStlc.STLCExtended.context)
   (t : MoreStlc.STLCExtended.tm) (T : MoreStlc.STLCExtended.ty),
 TypecheckerExtensions.type_check Gamma t = @Some MoreStlc.STLCExtended.ty T ->
 MoreStlc.STLCExtended.has_type Gamma t T)).
idtac "Assumptions:".
Abort.
Print Assumptions TypecheckerExtensions.type_checking_sound.
Goal True.
idtac " ".

idtac "#> TypecheckerExtensions.type_checking_complete".
idtac "Possible points: 3".
check_type @TypecheckerExtensions.type_checking_complete (
(forall (Gamma : MoreStlc.STLCExtended.context)
   (t : MoreStlc.STLCExtended.tm) (T : MoreStlc.STLCExtended.ty),
 MoreStlc.STLCExtended.has_type Gamma t T ->
 TypecheckerExtensions.type_check Gamma t = @Some MoreStlc.STLCExtended.ty T)).
idtac "Assumptions:".
Abort.
Print Assumptions TypecheckerExtensions.type_checking_complete.
Goal True.
idtac " ".

idtac " ".

idtac "Max points - standard: 5".
idtac "Max points - advanced: 5".
Abort.
